#ifdef SYSTEMC
/*
 * $Id$
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Two_Level_Branch_Predictor/include/Two_Level_Branch_Predictor.h"

namespace morpheo                    {
namespace behavioural {
namespace stage_1_ifetch {
namespace predictor {
namespace meta_predictor {
namespace two_level_branch_predictor {

  void Two_Level_Branch_Predictor::deallocation (void)
  {
    log_printf(FUNC,Two_Level_Branch_Predictor,"deallocation","Begin");

    delete in_CLOCK;
    delete in_NRESET;

    for (uint32_t i=0; i<_param._nb_prediction; i++)
      {
	delete  in_PREDICT_VAL                 [i];
	delete out_PREDICT_ACK                 [i];
	delete  in_PREDICT_ADDRESS             [i];
	if (_param._have_bht)
	delete out_PREDICT_BHT_HISTORY         [i];
	if (_param._have_pht)
	delete out_PREDICT_PHT_HISTORY         [i];
	if (_param._have_bht)
	  {
	delete signal_PREDICT_BHT_ACK          [i];
	delete signal_PREDICT_BHT_ADDRESS      [i];
	  }
	if (_param._have_pht)
	  {
	delete signal_PREDICT_PHT_ACK          [i];
	delete signal_PREDICT_PHT_ADDRESS      [i];
	  }

      }

    delete  in_PREDICT_VAL        ;
    delete out_PREDICT_ACK        ;
    delete  in_PREDICT_ADDRESS    ;
    if (_param._have_bht)
    delete out_PREDICT_BHT_HISTORY;
    if (_param._have_pht)
    delete out_PREDICT_PHT_HISTORY;
    if (_param._have_bht)
      {
    delete signal_PREDICT_BHT_ACK    ;
    delete signal_PREDICT_BHT_ADDRESS;
      }
    if (_param._have_pht)
      {
    delete signal_PREDICT_PHT_ACK    ;
    delete signal_PREDICT_PHT_ADDRESS;
      }

    for (uint32_t i=0; i<_param._nb_branch_complete; i++)
      {
	delete  in_BRANCH_COMPLETE_VAL         [i];
	delete out_BRANCH_COMPLETE_ACK         [i];
	delete  in_BRANCH_COMPLETE_ADDRESS     [i];
	if (_param._have_bht)
	delete  in_BRANCH_COMPLETE_BHT_HISTORY [i];
	if (_param._have_pht)
	delete  in_BRANCH_COMPLETE_PHT_HISTORY [i];
	delete  in_BRANCH_COMPLETE_DIRECTION   [i];
	if (_param._have_bht)
	  {
	delete signal_BRANCH_COMPLETE_BHT_ACK     [i];
	delete signal_BRANCH_COMPLETE_BHT_ADDRESS [i]; 
	  }
	if (_param._have_pht)
	  {
	delete signal_BRANCH_COMPLETE_PHT_ACK     [i];
	delete signal_BRANCH_COMPLETE_PHT_ADDRESS [i]; 
	  }
      }

    delete  in_BRANCH_COMPLETE_VAL        ;
    delete out_BRANCH_COMPLETE_ACK        ;
    delete  in_BRANCH_COMPLETE_ADDRESS    ;
    if (_param._have_bht)
    delete  in_BRANCH_COMPLETE_BHT_HISTORY;
    if (_param._have_pht)
    delete  in_BRANCH_COMPLETE_PHT_HISTORY;
    delete  in_BRANCH_COMPLETE_DIRECTION  ;
    if (_param._have_bht)
      {
    delete signal_BRANCH_COMPLETE_BHT_ACK    ;
    delete signal_BRANCH_COMPLETE_BHT_ADDRESS; 
      }
    if (_param._have_pht)
      {
    delete signal_BRANCH_COMPLETE_PHT_ACK    ;
    delete signal_BRANCH_COMPLETE_PHT_ADDRESS; 
      }

    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    

    if (_param._have_bht)
    delete component_Branch_History_Table ;
    if (_param._have_pht)
    delete component_Pattern_History_Table;
    delete component_Two_Level_Branch_Predictor_Glue;

    log_printf(FUNC,Two_Level_Branch_Predictor,"deallocation","End");
  };

}; // end namespace two_level_branch_predictor
}; // end namespace meta_predictor
}; // end namespace predictor
}; // end namespace stage_1_ifetch

}; // end namespace behavioural
}; // end namespace morpheo              
#endif
